/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals.jpa;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Entity;
import jakarta.persistence.ForeignKey;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.MapsId;
import jakarta.persistence.OneToOne;

/**
 *
 * @author Usuari
 */
@Entity
public class Esportista  {

    @Id
    private String dni;     // Podria  tenir qualsevol nom. Queda "mapat" per dni de Persona
    // Cal introduir-lo per què una Entity ha de tenir obligatòriament @Id
    // Podem facilitar un getDni, tot i que no seria necessari per què es podria saber fent getPersona().getDni()

    @OneToOne (optional=false, cascade=CascadeType.PERSIST)   // Recordem fetch=EAGER
    @JoinColumn(name="dni", nullable=false,
            foreignKey=@ForeignKey(name="ESPORTISTA_FK_DNI"))
    @MapsId
    private Persona persona;
    
    int pes;
    int altura;
    

    protected Esportista() {

    }

    public Esportista(Persona p, int pes, int altura) {
        setPersona(p);
        setPes(pes);
        setAltura(altura);
    }

    public Persona getPersona() {
        return persona;
    }

    public void setPersona(Persona persona) {
        this.persona = persona;
        this.dni = persona.getDni();    // Via anotacions sembla que NO és necessari, però SÍ amb marcatge XML
    }

    public int getPes() {
        return pes;
    }

    public void setPes(int pes) {
        this.pes = pes;
    }

    public int getAltura() {
        return altura;
    }

    public void setAltura(int altura) {
        this.altura = altura;
    }

    @Override
    public String toString() {
        return "Esportista{" + "dni=" + dni + ", persona=" + persona + ", pes=" + pes + ", altura=" + altura + '}';
    }



}
