/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals.jpa;

import java.io.Serializable;
import java.util.Objects;
import jakarta.persistence.Basic;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.Id;
import jakarta.persistence.OneToOne;

/**
 *
 * @author Usuari
 */
@Entity
public class Persona implements Serializable {

    @Id
    @Column(length = 15)
    private String dni;

    @Basic(optional = false)
    @Column(length = 50, nullable = false)
    private String nom;

    @OneToOne(mappedBy = "persona", fetch= FetchType.LAZY, cascade=CascadeType.REMOVE)  // No fa cas del LAZY
    Esportista esportista;

    @OneToOne(mappedBy = "persona", fetch= FetchType.LAZY, cascade=CascadeType.REMOVE)  // No fa cas del LAZY
    Professor professor;

    protected Persona() {
    }

    public Persona(String dni, String nom) {
        this.dni = dni;
        this.nom = nom;
    }

    public String getDni() {
        return dni;
    }

    public void setDni(String dni) {
        this.dni = dni;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public Esportista getEsportista() {
        return esportista;
    }

    public Professor getProfessor() {
        return professor;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 53 * hash + Objects.hashCode(this.dni);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Persona other = (Persona) obj;
        if (!Objects.equals(this.dni, other.dni)) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "Persona{" + "dni=" + dni + ", nom=" + nom + '}';
    }

}
