/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals.jpa;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Entity;
import jakarta.persistence.ForeignKey;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.MapsId;
import jakarta.persistence.OneToOne;

/**
 *
 * @author Usuari
 */
@Entity
public class Professor {

    @Id
    private String dni;     // Podria  tenir qualsevol nom. Queda "mapat" per dni de Persona
    // Cal introduir-lo per què una Entity ha de tenir obligatòriament @Id
    // Podem facilitar un getDni, tot i que no seria necessari per què es podria saber fent getPersona().getDni()
    
    @OneToOne (optional=false, cascade=CascadeType.PERSIST)   // Recordem fetch=EAGER
    @JoinColumn(name="dni", nullable=false,
            foreignKey=@ForeignKey(name="PROFESSOR_FK_DNI"))
    @MapsId
    private Persona persona;
    
    boolean esDurillo;

    protected Professor() {

    }

    public Professor(Persona p, Boolean esDurillo) {
        setPersona(p);
        setEsDurillo(esDurillo);
    }

    public Persona getPersona() {
        return persona;
    }

    public void setPersona(Persona persona) {
        this.persona = persona;
        this.dni=persona.getDni();
    }

    public Boolean getEsDurillo() {
        return esDurillo;
    }

    public void setEsDurillo(Boolean esDurillo) {
        this.esDurillo = esDurillo;
    }

    @Override
    public String toString() {
        return "Professor{" + "dni=" + dni + ", persona=" + persona + ", esDurillo=" + esDurillo + '}';
    }


}
