/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals.jpa;

import jakarta.persistence.EntityManager;
import jakarta.persistence.EntityManagerFactory;
import jakarta.persistence.Persistence;

/**
 *
 * @author Professor
 */
public class P02_InserirPersones {

    public static void main(String[] args) {

        if (args.length != 1) {
            System.out.println("Un únic argument amb el nom de la Unitat de Persistència");
            System.exit(1);
        }
        String up = args[0];
        EntityManagerFactory emf = null;
        EntityManager em = null;
        try {
            System.out.println("Intent amb " + up);
            emf = Persistence.createEntityManagerFactory(up);
            System.out.println("EntityManagerFactory creada");
            em = emf.createEntityManager();
            System.out.println("EntityManager creat");

            Persona p1 = new Persona ("PE01","Pepe Gotera");
            Esportista e1 = new Esportista(p1,70,170);
            Professor pr1 = new Professor(p1,false);
            Persona p2 = new Persona ("PE02","Josep Casajoana");
            Esportista e2 = new Esportista(p2,80,180);
            Persona p3 = new Persona ("PE03","Maria Dolça");
            Professor pr3 = new Professor(p3,true);
            Persona p4 = new Persona ("PE04","Anna Bolena");
            em.persist(e1);
            em.persist(pr1);
            em.persist(e2);
            em.persist(pr3);
            em.persist(p4);
            em.getTransaction().begin();
            em.getTransaction().commit();
            
        } catch (Exception ex) {
            System.out.println("Exception: " + ex.getMessage());
            System.out.print(ex.getCause() != null ? "Caused by:" + ex.getCause().getMessage() + "\n" : "");
        } finally {
            if (em.getTransaction().isActive()) {
                em.getTransaction().rollback();
            }
            if (em != null) {if (em.getTransaction().isActive()) {em.getTransaction().rollback();}em.close();
                System.out.println("EntityManager tancat");
            }
            if (emf != null) {
                emf.close();
                System.out.println("EntityManagerFactory tancada");
            }
        }
    }
}
