/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.milaifontanals.jpa;

import java.util.List;
import jakarta.persistence.EntityManager;
import jakarta.persistence.EntityManagerFactory;
import jakarta.persistence.Persistence;
import jakarta.persistence.Query;

/**
 *
 * @author Professor
 */
public class P05_RecuperarEsportistesOProfessors_OK {

    public static void main(String[] args) {

        if (args.length != 1) {
            System.out.println("Un únic argument amb el nom de la Unitat de Persistència");
            System.exit(1);
        }
        String up = args[0];
        EntityManagerFactory emf = null;
        EntityManager em = null;
        try {
            System.out.println("Intent amb " + up);
            emf = Persistence.createEntityManagerFactory(up);
            System.out.println("EntityManagerFactory creada");
            em = emf.createEntityManager();
            System.out.println("EntityManager creat");

            String cad = "select p from Persona p left join Esportista e on p=e.persona "
                    + "left join Professor pr on p= pr.persona "
                    + "where e.persona is not null or pr.persona is not null";
            Query q = em.createQuery(cad);

            List<Persona> ll = q.getResultList();
            if (ll.size() == 0) {
                System.out.println("No hi ha cap persona");
            } else {
                System.out.println("Esportistes i Professoors a la BD:");
                for (Persona p : ll) {
                    System.out.println("\t" + p);
                    if (p.getEsportista() != null) {
                        System.out.println("\t\tÉs esportista");
                    }
                    if (p.getProfessor() != null) {
                        System.out.println("\t\tÉs professor");
                    }
                }
            }
        } catch (Exception ex) {
            System.out.println("Exception: " + ex.getMessage());
            System.out.print(ex.getCause() != null ? "Caused by:" + ex.getCause().getMessage() + "\n" : "");
        } finally {
            if (em != null) {
                if (em.getTransaction().isActive()) {
                    em.getTransaction().rollback();
                }
                em.close();
                System.out.println("EntityManager tancat");
            }
            if (emf != null) {
                emf.close();
                System.out.println("EntityManagerFactory tancada");
            }
        }
    }
}
